:- module(test1, [
	m/0
   ]).

:- load_files(library(globals), [when(compile_time),if(changed)]).

m ::-
	$y := 4,
	 $z := 0,
	 n,
	 p,
	 $z = 8,
	 u.

n ::-
	n.

p ::-
	q.

q ::-
	r,
	 s,
	 Z is $z + 1,
	 $z := Z,
	 $x := 3.

q ::-
	$x := 6,
	 $z := 5.

r ::-
	q.

s ::-
	p,
	 t.

t ::-
	$y = 4.

u ::-
	v.

v ::-
	$x = 3.

/*****************************************************************
Analysis should yield:

	pred	uses	changes	defines	needs	provs	available
	  m	 xyz	 xyz	 xyz
	  n						  yz
	  p	  yz	 x z	 x	  yz	 x z	  yz
	  q	  yz	 x z	 x	  yz	 x z	  yz
	  r	  yz	 x z	 x	  yz	   z	  yz
	  s	  yz	 x z	 x	  yz	   z	  yz
	  t	  y			  y		  yz
	  u	 x			 x		 xyz
	  v	 x			 x		 xyz


So the code should be expanded to:

	m :- 	Y = 4,
		n,
		p(X, Y, Z0, Z),
		Z = 8,
		u.

	n :- n.

	p(X, Y, Z0, Z) :-
		q(X, Y, Z0, Z).

	q(X, Y, Z0, Z) :-
		r(_, Y, Z0, Z1),
		s(_, Y, Z1, Z2),
		Z is Z2 + 1.
		X = 3.
	q(X, _, Z, Z) :-
		X = 6.

	r(X, Y, Z0, Z) :-
		q(X, Y, Z0, Z).

	s(X, Y, Z0, Z) :-
		p(X, Y, Z0, Z),
		t(Y).

	t(Y) :- Y = 4.

	u(X) :- v(X).

	v(X):- X = 3.

*****************************************************************/
