%  This is a test of the 'scoped_to' construct.
%  
%  Analysis of this code should yield:
%  
%  pred	uses	changes	defines	needs	provides	available
%   a	abcdf	abdf	abdf	c	-		-
%   b	adf	adf	df	a	ad		ab
%   c	abcd	-	-	abcd	-		abcdf
%   d	ab	abd	d	ab	abd		abc
%   e	abcdf	f	f	abcd	-		abcd
%
%  Note that a/0 needs $c, but $c is not available; this should be reported as
%  an error

:- module(test6, [a/0]).

:- load_files(library(globals), [when(compile_time),if(changed)]).

a ::-
	$a := 1,
	$b := 2,
	b,
	c.

b ::-
	[$b := $a, $c := $b] scoped_to (
	    d,
	    e
	).

c ::-
	write($a),
	nl,
	write($b),
	nl,
	write($c),				% this is an error
	nl,
	write($d),
	nl.

d ::-
	D is $a + $b,
	$d := D,
	$a := 4,
	$b := 5.

e ::-
	F is $a + $b + $c + $d,
	$f := F,
	write($f),
	nl.
	
